
.backend_python_db_variables: &backend_python_db_variables
  variables:
    BACKEND_API_PATH: backend-python-db
    BACKEND_CACHE_KEY_PREFIX: api_ins
    POSTGRES_HOST_AUTH_METHOD: trust
    POSTGRES_DB: settings
    POSTGRES_USER: settings
    POSTGRES_PASSWORD: settings123
    DBHOSTNAME: "postgres"
    DBPORT: 5432
    DBUSER: "settings"
    DBPASSWORD: "settings123"
    DBNAME: "settings"

#####################################################################
# Test:
#####################################################################
backend-python-db:test:
  <<: *backend_python_db_variables
  image: ${CI_REGISTRY_IMAGE}/python-poetry:3.11
  tags: [ "xxllnc-shared", "arch:x86_64" ]
  rules:
    - if: '($CI_PIPELINE_SOURCE == "merge_request_event" || $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH) && $CI_PIPELINE_SOURCE != "schedule"'
  stage: Test
  services:
    - postgres:14.5-alpine
  script:
    - cd ${BACKEND_API_PATH}
    - poetry config virtualenvs.in-project true
    - poetry config virtualenvs.create true
    - poetry install
    - poetry run isort --check-only app
    - poetry run black --check app
    - poetry run ruff check .
    - poetry run mypy -p app
    - poetry run pytest -p no:cacheprovider --verbose --cov-branch --cov=. --junitxml=./junit.xml --cov-report=xml:./coverage.xml
  artifacts:
    name: backend_${CI_COMMIT_REF_SLUG}-${CI_PIPELINE_IID}
    expire_in: 4 days
    reports:
      junit: ${BACKEND_API_PATH}/junit.xml
      coverage_report:
        coverage_format: cobertura
        path: ${BACKEND_API_PATH}/coverage.xml
  cache:
    - key:
        files:
          - ${BACKEND_API_PATH}/poetry.lock
        prefix: ${BACKEND_CACHE_KEY_PREFIX}
      paths:
        - ${BACKEND_API_PATH}/.venv
      policy: pull-push

#####################################################################
# Build docker container:                                           #
#####################################################################
backend-python-db:build:
  <<: *backend_python_db_variables
  stage: Build
  image: docker:git
  tags: [ "xxllnc-shared", "arch:x86_64" ]
  rules:
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $CI_PIPELINE_SOURCE != "schedule"'
  script:
    - export VERSION=$(git tag --points-at $CI_COMMIT_SHA)
    - echo $VERSION
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker buildx build
      -f ${BACKEND_API_PATH}/Dockerfile
      --pull
      -t ${CI_REGISTRY_IMAGE}/${BACKEND_API_PATH}:${VERSION}
      --output type=registry
      "."
